package com.bubblergps.labeltst;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.bubblergps.labeltst", "com.bubblergps.labeltst.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.bubblergps.labeltst", "com.bubblergps.labeltst.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static int _col1 = 0;
public static int _col2 = 0;
public static int _lblangle = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lblgroovy = null;
public anywheresoftware.b4a.objects.LabelWrapper _btnsettings = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnlaunch = null;
public com.bubblergps.labeltst.de _de = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd0 = null;
int _col0 = 0;
int _col = 0;
anywheresoftware.b4a.objects.PanelWrapper _pnlback = null;
int _ar = 0;
int _ab = 0;
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd1 = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _cd2 = null;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 31;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 34;BA.debugLine="Dim cd, cd0 As ColorDrawable";
Debug.ShouldStop(2);
_cd = new anywheresoftware.b4a.objects.drawable.ColorDrawable();Debug.locals.put("cd", _cd);
_cd0 = new anywheresoftware.b4a.objects.drawable.ColorDrawable();Debug.locals.put("cd0", _cd0);
 BA.debugLineNum = 35;BA.debugLine="Dim col0 As Int = Colors.ARGB(255, 60, 76, 91)";
Debug.ShouldStop(4);
_col0 = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(255),(int)(60),(int)(76),(int)(91));Debug.locals.put("col0", _col0);Debug.locals.put("col0", _col0);
 BA.debugLineNum = 36;BA.debugLine="Dim col As Int = Colors.ARGB(255, 0, 128,0)";
Debug.ShouldStop(8);
_col = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(255),(int)(0),(int)(128),(int)(0));Debug.locals.put("col", _col);Debug.locals.put("col", _col);
 BA.debugLineNum = 37;BA.debugLine="cd.Initialize(col, lblAngle)";
Debug.ShouldStop(16);
_cd.Initialize(_col,_lblangle);
 BA.debugLineNum = 38;BA.debugLine="cd0.Initialize(col0, lblAngle)";
Debug.ShouldStop(32);
_cd0.Initialize(_col0,_lblangle);
 BA.debugLineNum = 39;BA.debugLine="Activity.Background = cd";
Debug.ShouldStop(64);
mostCurrent._activity.setBackground((android.graphics.drawable.Drawable)(_cd.getObject()));
 BA.debugLineNum = 40;BA.debugLine="Dim pnlback As Panel";
Debug.ShouldStop(128);
_pnlback = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("pnlback", _pnlback);
 BA.debugLineNum = 41;BA.debugLine="pnlback.Initialize(\"\")";
Debug.ShouldStop(256);
_pnlback.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 42;BA.debugLine="pnlback.Background = cd0";
Debug.ShouldStop(512);
_pnlback.setBackground((android.graphics.drawable.Drawable)(_cd0.getObject()));
 BA.debugLineNum = 43;BA.debugLine="Dim ar As Int = 100%x - 6dip";
Debug.ShouldStop(1024);
_ar = (int)(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(6)));Debug.locals.put("ar", _ar);Debug.locals.put("ar", _ar);
 BA.debugLineNum = 44;BA.debugLine="Dim ab As Int = 100%y - 6dip";
Debug.ShouldStop(2048);
_ab = (int)(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(6)));Debug.locals.put("ab", _ab);Debug.locals.put("ab", _ab);
 BA.debugLineNum = 45;BA.debugLine="Activity.AddView(pnlback, 3dip, 3dip, ar, ab)";
Debug.ShouldStop(4096);
mostCurrent._activity.AddView((android.view.View)(_pnlback.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(3)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(3)),_ar,_ab);
 BA.debugLineNum = 48;BA.debugLine="If btnLaunch.IsInitialized = False Then";
Debug.ShouldStop(32768);
if (mostCurrent._btnlaunch.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 49;BA.debugLine="btnLaunch.Initialize(\"Launch\")";
Debug.ShouldStop(65536);
mostCurrent._btnlaunch.Initialize(mostCurrent.activityBA,"Launch");
 };
 BA.debugLineNum = 51;BA.debugLine="btnLaunch.Text = \"Launch\"";
Debug.ShouldStop(262144);
mostCurrent._btnlaunch.setText((Object)("Launch"));
 BA.debugLineNum = 52;BA.debugLine="Activity.AddView(btnLaunch, 0, 50%y, 40%x, 50dip)";
Debug.ShouldStop(524288);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._btnlaunch.getObject()),(int)(0),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50)));
 BA.debugLineNum = 54;BA.debugLine="Dim cd1, cd2 As ColorDrawable";
Debug.ShouldStop(2097152);
_cd1 = new anywheresoftware.b4a.objects.drawable.ColorDrawable();Debug.locals.put("cd1", _cd1);
_cd2 = new anywheresoftware.b4a.objects.drawable.ColorDrawable();Debug.locals.put("cd2", _cd2);
 BA.debugLineNum = 55;BA.debugLine="lblGroovy.Initialize(\"lblGroovy\")";
Debug.ShouldStop(4194304);
mostCurrent._lblgroovy.Initialize(mostCurrent.activityBA,"lblGroovy");
 BA.debugLineNum = 56;BA.debugLine="cd1.Initialize(col1, lblAngle)";
Debug.ShouldStop(8388608);
_cd1.Initialize(_col1,_lblangle);
 BA.debugLineNum = 57;BA.debugLine="cd2.Initialize(col2, lblAngle)";
Debug.ShouldStop(16777216);
_cd2.Initialize(_col2,_lblangle);
 BA.debugLineNum = 59;BA.debugLine="lblGroovy.Background = cd2";
Debug.ShouldStop(67108864);
mostCurrent._lblgroovy.setBackground((android.graphics.drawable.Drawable)(_cd2.getObject()));
 BA.debugLineNum = 60;BA.debugLine="lblGroovy.TextColor = Colors.Black";
Debug.ShouldStop(134217728);
mostCurrent._lblgroovy.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 61;BA.debugLine="lblGroovy.Text = \"\"\"Launch button launch button\"\"\"";
Debug.ShouldStop(268435456);
mostCurrent._lblgroovy.setText((Object)("\"Launch button launch button\""));
 BA.debugLineNum = 62;BA.debugLine="lblGroovy.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)";
Debug.ShouldStop(536870912);
mostCurrent._lblgroovy.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL,anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 63;BA.debugLine="Activity.AddView(lblGroovy, 10%x, 90%y, 80%x, 10%x)";
Debug.ShouldStop(1073741824);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lblgroovy.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(10),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(90),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(80),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(10),mostCurrent.activityBA));
 BA.debugLineNum = 65;BA.debugLine="If btnSettings.IsInitialized = False Then";
Debug.ShouldStop(1);
if (mostCurrent._btnsettings.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 66;BA.debugLine="btnSettings.Initialize(\"btnSettings\")";
Debug.ShouldStop(2);
mostCurrent._btnsettings.Initialize(mostCurrent.activityBA,"btnSettings");
 };
 BA.debugLineNum = 68;BA.debugLine="btnSettings.Background = cd2";
Debug.ShouldStop(8);
mostCurrent._btnsettings.setBackground((android.graphics.drawable.Drawable)(_cd2.getObject()));
 BA.debugLineNum = 69;BA.debugLine="btnSettings.TextColor = Colors.Black";
Debug.ShouldStop(16);
mostCurrent._btnsettings.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 70;BA.debugLine="btnSettings.Text = \"Settings\"";
Debug.ShouldStop(32);
mostCurrent._btnsettings.setText((Object)("Settings"));
 BA.debugLineNum = 71;BA.debugLine="btnSettings.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)";
Debug.ShouldStop(64);
mostCurrent._btnsettings.setGravity(anywheresoftware.b4a.keywords.Common.Bit.Or(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL,anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 72;BA.debugLine="Activity.AddView(btnSettings, 30%x, 2%y, 40%x, 10%x)";
Debug.ShouldStop(128);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._btnsettings.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(30),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(2),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(40),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(10),mostCurrent.activityBA));
 BA.debugLineNum = 75;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 81;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(65536);
 BA.debugLineNum = 83;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 77;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(4096);
 BA.debugLineNum = 79;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 42557, new int[] {3, 2}, "4d962d80-bdd3-45dc-a65d-d7c7316a189b");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
de._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (de.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}


            if (de.previousOne != null) {
				Activity a = de.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 24;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 27;BA.debugLine="Dim lblGroovy, btnSettings As Label";
mostCurrent._lblgroovy = new anywheresoftware.b4a.objects.LabelWrapper();
mostCurrent._btnsettings = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim btnLaunch As Button";
mostCurrent._btnlaunch = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _launch_click() throws Exception{
		Debug.PushSubsStack("Launch_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 85;BA.debugLine="Sub Launch_Click";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 86;BA.debugLine="StartActivity(\"de\")";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)("de"));
 BA.debugLineNum = 87;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim col1 As Int = Colors.ARGB(255, 255, 214, 140)";
_col1 = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(255),(int)(255),(int)(214),(int)(140));
 //BA.debugLineNum = 19;BA.debugLine="Dim col2 As Int = Colors.ARGB(255, 178, 194, 254)";
_col2 = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(255),(int)(178),(int)(194),(int)(254));
 //BA.debugLineNum = 20;BA.debugLine="Dim lblAngle As Int = 10";
_lblangle = (int)(10);
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"col1",_col1,"col2",_col2,"lblAngle",_lblangle,"lblGroovy",_lblgroovy,"btnSettings",_btnsettings,"btnLaunch",_btnlaunch,"de",Debug.moduleToString(com.bubblergps.labeltst.de.class)};
}
}
